local mod = RW:Boss("Professor Putricide", "Icecrown Citadel", "Icecrown Citadel", "The Plagueworks")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_profputricide]]

---------------------------
-- Variables
--Bloat
local iBloat, mBloat, wBloat, wBloatNewTargetSoon, tBloatCast
--Volatile Ooze Adhesive 
local iVolatiel, mVolatile, wVolatile, tVolatileCast
--Puddle
local wPuddle, mPuddle
-- Unstable Experiment 
local wExperiment, tExperimentCast, tExperimentCD
-- Choking Gas 
local wGas, mGas, tGasDur
-- Choking Gas Bomb
local wGasBomb, tGasBombExplode
--Malleable Goo
local wMalleableGoo, tMalleableGooDur, mMalleableGoo, iMalleableGoo
-- Mutated Plague
local mMutatedP, tMutadedPDur, tMutadedPCD
-- Tear Gas
local tTearGasDur

-- Phases
local mPhase

---------------------------
-- Init	
function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Professor Putricide"
		L.info = "Untested mod, warnings and timers may be wrong"
		
		L.YellPull = "Good news, everyone! I think I perfected a plague that will destroy all life on Azeroth!"
		L.YellKill = "Bad news, everyone! I don't think I'm going to make it."
		
		L.health_frames = "Show stack frame for "..GetSpellInfo(70215)
		
		L.bloat_new_tartget_soon = "New target for Gas Cloud Soon!"
		L.bloat_new_tartget_soon_opt = "Warn when the Gas Cloud is about to pick a new target"
		
		L.adds = "Gas Cloud/Ooze"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(36678, L.YellPull)
	mod:SetWin(36678, L.YellKill)
	
	self:AddToCategory(L.name, 71968, 72460, 72451, 72297, 71255, 72868, 71617)
	self:AddToCategory(L.adds , 70215, 72838, L.health_frames)
	
	self:AddBoolOption("HealthFrame", L.health_frames, nil, nil, select(3, GetSpellInfo(70215)))
	
	tBloatCast		= self:CastTimer(3, 70215)
	tVolatileCast	= self:CastTimer(3, 72838)
	tExperimentCast = self:CastTimer(71968)
	tExperimentCD	= self:CDTimer(40, 71968)
	tGasDur			= self:DurTargetTimer(15, 72460)
	tGasBombExplode = self:DurTimer(20, 71255)
	tMutadedPDur	= self:DurTargetStackTimer(50, 72451, nil, nil, false)
	tMutadedPCD		= self:CDTimer(10, 72451, nil, nil, false)
	tTearGasDur		= self:DurTimer(15, 71617)
	tMalleableGooDur = self:DurTargetTimer(20, 72297)
	
	wBloat			= self:RunawayWarning(70215)
	wBloatNewTargetSoon = self:CustomWarning(L.bloat_new_tartget_soon, L.bloat_new_tartget_soon_opt, 70215)
	wVolatile		= self:Warning(72838)
	wPuddle			= self:RunawayWarning(72868)
	wExperiment		= self:CastWarning(71968)
	wGasBomb		= self:CastWarning(71255)
	wGas			= self:InformWarning(72460)
	wMalleableGoo	= self:InformWarning(72297)
	
	mBloat			= self:TargetMessage(70215)
	mVolatile		= self:TargetMessage(72838)
	mPuddle			= self:Message(72868, nil, nil, false)
	mGas			= self:TargetMessage(72460)
	mMutatedP		= self:TargetStackMessage(72451, nil, nil, false)
	mMalleableGoo	= self:TargetMessage(72297)
	mPhase			= self:PhaseMessage()
	
	iBloat			= self:Icon("SKULL", 70215, false)
	iVolatiel		= self:Icon("SKULL", 72838, false)
	iMalleableGoo	= self:Icon("CROSS", 72297, false, 8)
end

---------------------------
-- Locals
local tearGasSpamm
local puddleSpamm
local phase
local bloatStacks
local bloatName, _, bloatIcon = GetSpellInfo(70215)

local function updateStack()
	return bloatStacks, 10
end

---------------------------
-- Start
function mod:OnEngage(trigger)
	self:Track("Bloat", 70215, 72860, 72859, 72858, 72832, 72833, 72455, 70672)
	self:Track("Volatile", 72838, 70447, 72836, 72837)
	self:Track("Puddle", 72868, 70346, 72869, 70341)
	self:Track("Experiment", 71968, 70351, 71966, 71967)
	self:Track("GasBomb", 71255)
	self:Track("Gas", 72460, 71278, 72620, 72619)
	self:Track("MalleableGoo", 72297, 70853, 72458, 72548, 72549, 72550, 72873, 72874)
	self:Track("MutadedP", 72451, 72672, 72671, 72463,   72506, 72454, 72507, 72464)
	self:Track("TearGas", 71617, 71615, 71618)
	
	tearGasSpamm = 0
	puddleSpamm = 0
	phase = 1
	bloatStacks = 10
	
	self:Msg(L.info)
end

function mod:Bloat(event, args)
	if event == "SPELL_CAST_START" then
		tBloatCast:Start()

	elseif event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wBloat:Show()
		end
		mBloat:Show(args.dName)
		iBloat:Show(args.dName)
		if self.db.profile.HealthFrame then
			self:SendMessage("RW_AddHealthFrame", updateStack, bloatName, bloatIcon, "STACK")
		end
	
	elseif event == "SPELL_AURA_REMOVED_DOSE" then
		bloatStacks = args.amount or 1
		if (args.amount or 9) <= 3 then
			wBloatNewTargetSoon:Show()
		end
		
	elseif event == "SPELL_AURA_REMOVED" then
		if self.db.profile.HealthFrame then
			self:SendMessage("RW_RemoveHealthFrame", updateStack)
		end
	end
end

function mod:Volatile(event, args)
	if event == "SPELL_CAST_START" then
		tVolatileCast:Start()

	elseif event == "SPELL_AURA_APPLIED" then
		iVolatiel:Show(args.dName)
		mVolatile:Show(args.dName)
		if not args:IsPlayer() then
			wVolatile:Show()
		end
	end
end

function mod:Puddle(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wPuddle:Show()
		end
	
	elseif event == "SPELL_CAST_SUCCESS" and (GetTime() - puddleSpamm) > 2 then
		mPuddle:Show()
		puddleSpamm = GetTime()
	end
end

function mod:Experiment(event, args)
	if event == "SPELL_CAST_START" then
		tExperimentCast:Start()
		tExperimentCD:Start()
		wExperiment:Show()
	end
end

function mod:GasBomb(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tGasBombExplode:Start()
		wGasBomb:Show()
	end
end

function mod:Gas(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wGas:Show()
			tGasDur:Start(args.dName)
		end
		mGas:Show(args.dName)
	end
end

function mod:MalleableGoo(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wMalleableGoo:Show()
			tMalleableGooDur:Start(args.dName)
		end
		mMalleableGoo:AddDelayTarget(args.dName)
		mMalleableGoo:DelayedShow(0.4)
		
	elseif event == "SPELL_AURA_REMOVED" then
		tMalleableGooDur:Stop(args.dName)
		
	elseif event == "SPELL_CAST_SUCCESS" then
		local target = self:GetMobTarget()
		if target then
			iMalleableGoo:Show(target)
		end
	end
end

function mod:MutadedP(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		mMutatedP:Show(args.dName, args.amount or 1)
		tMutadedPDur:Start(args.dName, args.amount or 1)
		tMutadedPCD:Start()
		
	elseif event == "SPELL_AURA_REMOVED" then
		tMutadedPDur:Stop(args.dName)
	end
end

function mod:TearGas(event, args)
	if event == "SPELL_CAST_START" then
		phase = phase + 1
		mPhase:Show(phase)
	
	elseif event == "SPELL_AURA_APPLIED" and (GetTime() - tearGasSpamm) > 2 then
		tTearGasDur:Start()
	end
end